/*******************************************************************
*  Includes
*******************************************************************/
#include <ultra64.h>
#include "thread.h"
#include "textlib.h"
#include "cont.h"


/*******************************************************************
*  Externals
*******************************************************************/
extern u16     *bitmap_buf;
extern u16      bitmap_buf1[];
extern u16      bitmap_buf2[];
extern u16      Graphic[320 * 1];

/******************************************************************
*  Prototypes
*******************************************************************/
int             GetButton (void);
extern void     plasma_main (void);

/*******************************************************************
*  Defines, Queues etc
*******************************************************************/
#define NUM_MESSAGE 2

OSMesgQueue     retraceMessageQ;
OSMesgQueue     pifMesgQueue;

OSMesg          retraceMessageBuf;
OSMesg          dummyMessage;
OSMesg          pifMesgBuf[NUM_MESSAGE];

u16             button;
u16             tempbuf[320 * 17];
OSContPad     **pad;



/*******************************************************************
*  Main Thread / Entry point
*******************************************************************/
void
mainproc (void *arg)
{

    // init variables
    int             controller;


    // start Vsync queue
    osCreateMesgQueue (&retraceMessageQ, &retraceMessageBuf, 1);
    osViSetEvent (&retraceMessageQ, dummyMessage, 1);

    // init screen res etc
    init_draw ();

    // set background colour
    setbgcolor (0, 0, 25);
    clear_draw ();
    set_xy (5, 5);
    setcolor (255, 255, 255);

    controller = initControllers (MAXCONTROLLERS);
    // check a controller is plugged in
    if (controller < 1)
    {
	set_xy (0, 5);
	draw_center ("No Controller!", 0);
    }

    clear_draw ();

    // call plasma routines
    plasma_main ();

    // a dead loop
    for (;;);

}


/*******************************************************************
*  Sub Routine Read controller
*******************************************************************/
int
GetButton (void)
{
    osWritebackDCacheAll ();
    osWritebackDCacheAll ();

    button = 0;
//    while (!button)
    {
	pad = ReadController (0);
	if (pad == 0)
	    button = 0;
	else
	    button = pad[0]->button | pad[1]->button | pad[2]->button | pad[3]->button;
	osWritebackDCacheAll ();
    }
    return button;
}
